/* eslint-disable camelcase */
const bcrypt = require('bcryptjs')
const { check, validationResult } = require('express-validator')

const jwt = require('jsonwebtoken')
const UserModel = require('../../../models/UserModel')

const changePasswordValidationRules = () => {
  return [
    check('new_password')
      .notEmpty().withMessage('رمز عبور نمی‌تواند خالی باشد')
      .isLength({ min: 8, max: 25 }).withMessage('رمز عبور نباید کوتاه تر از 8 کاراکتر باشد')
      .matches(/^(?=.*[a-zA-Zآ-ی])(?=.*\d).{8,}$/u).withMessage('رمز عبور باید شامل حروف و اعداد باشد')
  ]
}
const changePasswordUser = async (req, res, next) => {
  try {
    const { new_password } = req.body
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id
    // اعتبارسنجی ورودی ها
    const errors = validationResult(req)
    if (!errors.isEmpty()) {
      return res.status(422).json({ errors: errors.array() })
    }

    // یافتن کاربر با شماره موبایل
    const user = await UserModel.findById(userId)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }
    // هش کردن پسورد جدید و ذخیره در دیتابیس
    const hashedPassword = await bcrypt.hash(new_password, 10)
    user.password = hashedPassword
    await user.save()

    return res.json({
      message: 'کلمه عبور با موفقیت ذخیره شد'
    })
  } catch (error) {
    next(error)
  }
}

const editChangePasswordUser = async (req, res, next) => {
  try {
    const { mobile, new_password } = req.body
    const user = await UserModel.findOne({ mobile })
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // هش کردن پسورد جدید و ذخیره در دیتابیس
    const hashedPassword = await bcrypt.hash(new_password, 10)
    user.password = hashedPassword
    await user.save()

    return res.json({
      message: 'کلمه عبور با موفقیت تغییر یافت'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  changePasswordUser, changePasswordValidationRules, editChangePasswordUser
}
